/**
 * Defensive.java
 *Ein Spieler mit defensiver Taktik
 *
 *
 * @author <a href="mailto:unbequemecouch@web.de">Matthias Bernges</a>
 * @version
 */

public class Defensive extends Player{

    private java.util.Vector v;
    private final int borderl=-52, borderr=0;
    private int lborder, rborder;
    private final int maxdist=0;
    private double  maxwinkel=20;
    /**
     *Generiert einen defensiven Spieler
     *@param X Die Standard X Position zu der der Spieler immer wieder zurckkehrt
     *@param Y Die Standard Y Position zu der der Spieler immer wieder zurckkehrt
     *@param Team Der Teamname zu dem der Spieler gehrt
     *@param Host Der Hostname des Servers
     *@param Port Der Portname des Servers
     */
    public Defensive (int X, int Y,String Team, String Host, int Port){
	super(X,Y,Team, Host, Port);
    }

    /**
     *Ausfhren der nchsten Aktion
     *Der Spieler entscheidet Anahnd gegebener Informationen welche Aktion er als nchstes ausfhrt (z.B. zum Ball zu laufen).
     */
    public void doSomething(){
	//	System.out.println("Defensive: doSomething");
	/*if (direction){
	    lborder=borderl;
	    rborder=borderr;
	}
	else{
	    lborder=borderr*-1;
	    rborder=borderl*-1;
	}*/

	if (mode==0){
	    int i;
	    if (defX>0)
		i=-1;
	    /*else if((!direction)&&(defX<0))
		i=1;*/
	    else i=defX;
	    System.out.println("Defensive: moveToPosition: "+i+" "+defY);
	    actor.moveToPosition(i,defY);
	    mode=1;
	    return;
	}

	v=world.getObjects();
	for (int i=0;i<v.size();i++)
	    System.out.println("Defensive: Element: "+(Element)v.elementAt(i));
	if (v.size()<1) return;
	me=(Element)v.firstElement();
	try{
	    setBall();
	}catch (NoBallException e){
	    System.out.println("Defensive: searchBall");
	    actor.searchBall();
	    return;
	}

	if(Strecke(ball.x,ball.y,me.x,me.y)<10) actor.callBallPosition();
	if(ballInArea()){
	    if (winkel()){
		if (distanz()){
		    if (playerForward()!=null){
			Element e=playerForward();
			System.out.println("Defensive: shootToPositon: "+e.x+" "+e.y);
			actor.shootToPosition(e.x,e.y);
		    }//playerBetweenGoal
		    else {
			System.out.println("Defensive: shootToGoal");
			actor.shootToGoal();
		    }//else playerBetweenGoal
		}//distanz
		else{
		    if(playerBetweenBall()){
			System.out.println("Defensive: walkToPosition: "+defX+" "+defY+" ");
			if (Strecke(me.x,me.y,defX,defY)>3)
			    actor.walkToPosition(defX,defY);
		    }//playerBetweenBall
		    else{
			System.out.println("Defensive: runToBall");
			actor.runToBall();
		    }//else playerBetweenBall
		}//else distanz
	    }//ballInArea
	    else{
		System.out.println("Defensive: turnToBall");
		actor.turnToBall();
	    }//else allInArea
	}//winkel
	else {
	    System.out.println("Defensive: walkToPosition: "+defX+" "+defY);
	    if (Strecke(me.x,me.y,defX,defY)>3)
		actor.walkToPosition(defX,defY);
	}//else winkel

    }


    //berprft ob ein anderer Spieler nher am Ball ist
    private boolean playerBetweenBall() {
	Element e;
	for (int i=1;i<v.size();i++){
	    e=(Element)v.elementAt(i);
	    if ((e.type>=200)&&(e.type<300))
		if (Strecke(me.x,me.y,ball.x,ball.y)>
		    Strecke(e.x,e.y,ball.x,ball.y))
		    return true;
	}
	return false;
    }
    //berprft ob sich ein Spieler weiter vorne befindet
    private Element playerForward(){
	Element e;
	for (int i=1;i<v.size();i++){
	    e=(Element)v.elementAt(i);
	    if ((e.type>200)&&(e.type<300))
		if (e.x>me.x)
		    return e;
	}
	return null;
    }

    private boolean ballInArea(){
	int type;
	if ((ball.x<borderl)||(ball.x>borderr))
	    return false;
	return true;
    }

    //berprft ob die Distanz zum Ball kurz genug ist 
    private boolean distanz(){
	//if ((Math.abs(ball.x-me.x)>maxdist)||(Math.abs(ball.y-me.y)>maxdist))
	if(Strecke(ball.x, ball.y, me.x, me.y)>maxdist)
	    return false;
	return true;
    }

    //berprft ob der Winkel zum Ball gnstig ist
    private boolean winkel(){
	double d;
        d = ball.direction;
	System.out.println("Defensive: Winkel: "+d);
	return (Math.abs(d)<=maxwinkel);
	
    }

    //Gibt den Ball aus dem Vektor zurck
    private void setBall() throws NoBallException {
	Element e;
	int i=0;
	do{
	    try{
		e=(Element)v.elementAt(i);
	    }catch (ArrayIndexOutOfBoundsException ex){
		throw (new NoBallException("Kein Ball in Elementliste"));
	    }
	    i++;
	} while (e.type!=1);
	ball=e;
	do{
	    try{
		e=(Element)v.elementAt(i);
	    }catch (ArrayIndexOutOfBoundsException ex){
		ballOld=ball;
		return;
	    }
	    i++;
	} while (e.type!=1);
	ballOld=e;
    }

    //Rechnet die Strecke zwischen 2 Koordinatenpunkten aus.
    private double Strecke(int x1, int y1, int x2, int y2){
	return Math.sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
    }


}// Defensive
