/**
 * Middle.java
 *
 *
 *
 * @author <a href="mailto: "Matthias Bernges</a>
 * @version
 */

import java.util.*;
import java.lang.Math.*;
public class Middle extends Player{
    private Vector v;
    private final int borderl=-30, borderr=30;
    private int lborder, rborder;
    private final double maxdist=0.2;
    private double  maxwinkel=20;

    /**
     *Generiert einen Mittelfeldspieler
     *@param X Die Standard X Position zu der der Spieler immer wieder zurckkehrt
     *@param Y Die Standard Y Position zu der der Spieler immer wieder zurckkehrt
     *@param Team Der Teamname zu dem der Spieler gehrt
     *@param Host Der Hostname des Servers
     *@param Port Der Portname des Servers
     */
    public Middle (int X, int Y, String Team, String Host, int Port){
	super(X,Y,Team, Host, Port);
    }

    /**
     *Ausfhren der nchsten Aktion
     *Der Spieler entscheidet Anahnd gegebener Informationen welche Aktion er als nchstes ausfhrt (z.B. zum Ball zu laufen).
     */
    public void doSomething(){
	/*if (direction){
	    lborder=borderl;
	    rborder=borderr;
	}
	else{
	    lborder=borderr*-1;
	    rborder=borderl*-1;
	}*/

	if (mode==0){
	    int i;
	    if (defX>0)
		i=-1;
	    /*else if((!direction)&&(defX<0))
		i=1;*/
	    else i=defX;
            actor.moveToPosition(i,defY);
	    mode=1;
	    return;
	}
	v=world.getObjects();
	if (v.size()<1) return;
	me=(Element)v.firstElement();
	try{
	    setBall();
	    System.out.println("Middle: "+(Element)ball);
	}catch (NoBallException e){
	    System.out.println("Middle: searchball");
	    actor.searchBall();
	    return;
	}
	if(Strecke(ball.x,ball.y,me.x,me.y)<10) actor.callBallPosition();
        
      if(me.x<borderr && me.x>borderl){  
	if (ballInArea()){
	   if (winkel()){
		if (distanz()){
		    if (playerForward()!=null){
			Element e=playerForward();
			System.out.println("Middle: shootToPosition (pass)");
			actor.shootToPosition(e.x,e.y);
		    }//playerForward
		    else {		
			System.out.println("Middle: shootToPositin");
			actor.shootToGoal();
		    }//else playerForward
		}//distanz
		else{
		    if (playerBetweenBall()){
			System.out.println("Middle: walkToPosition (home)");
			actor.walkToPosition(defX,defY);
		    }//playerBetweenBall
		    else{
			System.out.println("Middle: runTOBall");
			actor.runToBall();
		    }//else playerBetweenBall
		}//else distanz
	    }//ball in Area
	    else {
	    System.out.println("Middle: TurnToBall");
	    actor.turnToBall();

	    }//else BallInArea
	}//winkel
	else {
               System.out.println("Middle: walkToPosition (home)");
               
               actor.walkToPosition(defX,defY);
               

	}//else winkel
  
     }else {actor.walkToPosition(defX,defY);}
    }
    

    //Stellt fest ob sich der Ball in dem Bereich des Spielfeldes
    //Befindet fr den der Spieler Zustndig ist
    private boolean ballInArea(){
	int type;
	if ((ball.x<borderl)||(ball.x>borderr))
	    return false;
	return true;
    }

    //berprft ob die Distanz zum Ball kurz genug ist
    private boolean distanz(){
	if (Strecke(ball.x, ball.y, me.x, me.y)>maxdist)
	    return false;
	return true;
    }

    //berprft ob sich ein Spieler weiter vorne befindet
    private Element playerForward(){
	Element e;
	for (int i=1;i<v.size();i++){
	    e=(Element)v.elementAt(i);
	    if ((e.type>=200)&&(e.type<300))
		if (e.x>me.x)
		    return e;
	}
	return null;
    }

    //berprft ob ein anderer Spieler nher am Ball ist
    private boolean playerBetweenBall() {
	Element e;
	for (int i=1;i<v.size();i++){
	    e=(Element)v.elementAt(i);
	    if ((e.type>200)&&(e.type<300))
		if (Strecke(me.x,me.y,ball.x,ball.y)>
		    Strecke(e.x,e.y,ball.x,ball.y))
		    return true;
	}
	return false;
    }

    //berprft ob der Winkel zum Ball gnstig ist
    private boolean winkel(){
	double d;
	d = ball.direction;
	if (Math.abs(d)>maxwinkel) return false;
	return true;
    }

    //Gibt den Ball aus dem Vektor zurck
    private void setBall() throws NoBallException {
	Element e;
	int i=0;
	do{
	    try{
		e=(Element)v.elementAt(i);
	    }catch (ArrayIndexOutOfBoundsException ex){
		throw (new NoBallException("Kein Ball in Elementliste"));
	    }
	    i++;
	} while (e.type!=1);
	ball=e;
	do{
	    try{
		e=(Element)v.elementAt(i);
	    }catch (ArrayIndexOutOfBoundsException ex){
		ballOld=ball;
		return;
	    }
	    i++;
	} while (e.type!=1);
	ballOld=e;
    }

    //Rechnet die Strecke zwischen 2 Koordinatenpunkten aus.
    private double Strecke(int x1, int y1, int x2, int y2){
	return Math.sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
    }

}// Middle
