/**
 * MonitorSocket.java
 *
 *Socket fr die Serverseitige Kommunikation zwischen dem Team und der Visualisierung des Weltbilds
 *
 * @author <a href="mailto:unbequemecouch@web.de">Matthias Bernges</a>
 * @version
 */
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
public class MonitorSocket extends Thread{
    Socket s;
    Team t;

    /**
     *Generiert einen <code>MonitorSocket</code>
     *@param s das Socketobjekt das fr die Kommunikation zustndig ist
     *@param t Das Team von dem der <code>MonitorSocket</code> die Inforamtionen erhalten kann
     */
    public MonitorSocket (Socket s, Team t){
	this.t=t;
	this.s=s;
    }

    public void run(){
	try{
	    ObjectOutputStream out = new ObjectOutputStream(s.getOutputStream());
	    BufferedReader in = new BufferedReader( new InputStreamReader(s.getInputStream()));
	    String inputLine, outputLine;         
	    
	    while ((inputLine = in.readLine()) != null) 
		{ 
		    int i;
		    try{
			i=Integer.parseInt(inputLine);
System.out.println("MonitorSocket: in: "+i);
			if (i>=0&&i<=10){
			    System.out.println("MonitorSocket: out456:");
			    Vector v=t.getObjects(i);
			    //System.out.println("MonitorSocket: out789:"+(Element)v.firstElement());
			    //out.writeObject(v);

//wenn von rechts nach links
                            if(t.p[i].getDirection())
			    {out.writeObject(v);}
                            else{
				for(int m=0;m<v.size();m++)
				{int tp=((Element)v.elementAt(m)).type;
                                 ((Element)v.elementAt(m)).type=-1*tp;}
				out.writeObject(v);}
//Bis hier fuer Feld.java

    System.out.println("MonitorSocket: out123:"+(Element)v.firstElement());
			}
		    }catch (NumberFormatException nfe){}
		
		}
	    out.close();
	    in.close();
	    s.close();
	    System.out.println("MonitorSocket: run beendet");
	} catch (Exception e){
	    System.err.println("MonitorSocket: error: "+e);
	    e.printStackTrace();
	}
    }
        
}// MonitorSocket
