/**
 * Storm.java
 *
 *
 *
 * @author <a href="mailto:unbequemecouch@web.de">Matthias Bernges</a>
 * @version
 */

public class Storm extends Player{

    private java.util.Vector v;
    private final int borderl=10, borderr=52;
    private int lborder, rborder;
    private final int pfostenl=-7, pfostenr=7;
    private final double maxdist=0.2;
    private double  maxwinkel=10;

    /**
     *Generiert einen Strmer
     *@param X Die Standard X Position zu der der Spieler immer wieder zurckkehrt
     *@param Y Die Standard Y Position zu der der Spieler immer wieder zurckkehrt
     *@param Team Der Teamname zu dem der Spieler gehrt
     *@param Host Der Hostname des Servers
     *@param Port Der Portname des Servers
     */
    public Storm (int X, int Y, String Team, String Host, int Port){
	super(X,Y,Team, Host, Port);
    }

    /**
     *Ausfhren der nchsten Aktion
     *Der Spieler entscheidet Anahnd gegebener Informationen welche Aktion er als nchstes ausfhrt (z.B. zum Ball zu laufen).
     */
    public void doSomething(){
	//	if (direction){
	    lborder=borderl;
	    rborder=borderr;
	    //	}
	/*	else{
	    lborder=borderr*-1;
	    rborder=borderl*-1;
	}*/

	if (mode==0){
	    int i;
	    /*if ((direction)&&(defX>0))
		i=0;
	    else if((!direction)&&(defX<0))
		i=0;
		else*/ i=-1;
	    actor.moveToPosition(i,defY);
	    System.out.println("Storm: Move: "+i+defY);
	    mode=1;
	    return;
	}
	//System.out.println("I do Something!!!");
	v=world.getObjects();
	if (v.size()<1) return;
	for (int i=0;i<v.size();i++)
	    System.out.println("Storm: "+(Element)v.get(i));
	me=(Element)v.firstElement();
	try{
	    setBall();
	    // System.out.println("Ball gefunden");
	}catch (NoBallException e){
	    //  System.out.println("Kein ball gefunden");
	    actor.searchBall();
	    return;
	}
        //System.out.println("Storm: "+(Element) ball);
	if(Strecke(ball.x,ball.y,me.x,me.y)<10) actor.callBallPosition();
	//System.out.println("beginn der ifs");
        
	//      if(me.x>borderl){  
      if(ballInArea()){
        if (winkel()){
		if (distanz()){
		    if (playerBetweenGoal()!=null){
			System.out.println("Storm: ShootToPosition (pass)");
			actor.shootToPosition(playerBetweenGoal().x,playerBetweenGoal().y);
		    }//playerBetweenGoal
		    else {
			System.out.println("Storm: shootToGoal");
			actor.shootToGoal();
		    }//else playerBetweenGoal
		}//distanz
		else{
		    if(playerBetweenBall()){
			System.out.println("Storm: Walking home");
			actor.walkToPosition(defX,defY);
		    }//playerBetweenBall
		    else{
			System.out.println("Storm: runToBall");
			actor.runToBall();
		    }//else playerBetweenBall
		}//else distanz
            }// else winkel
	    else{
                System.out.println("Storm: turnToBall");
                actor.turnToBall();

	    }//else allInArea
          }
	else {
               System.out.println("Storm: walking home ball ausserhalb)");
	       if(Strecke(me.x, me.y, defX, defY)>3)
               actor.walkToPosition(defX,defY);
	       //               actor.searchBall();

	}//else winkel
      // }else {actor.walkToPosition(defX,defY);}
    }
    

    //berprft ob ein Spieler zwischen dem Tor ist
    private Element playerBetweenGoal() {
	//System.out.println("check betweengoal");
	Element e;
	for (int i=1;i<v.size();i++){
	    e=(Element)v.elementAt(i);
	    //System.out.println(e.toString());
	    if (beforeGoal(e)) return e;
	}
	return null;
    }

    //berprft ob ein anderer Spieler nher am Ball ist
    private boolean playerBetweenBall() {
	//System.out.println("check betweenBall");
	Element e;
	for (int i=1;i<v.size();i++){
	    e=(Element)v.elementAt(i);
	    if ((e.type>200)&&(e.type<300))
		if (Strecke(me.x,me.y,ball.x,ball.y)>
		    Strecke(e.x,e.y,ball.x,ball.y))
		    return true;
	}
	return false;
    }

    private boolean ballInArea(){
	//System.out.println("check inArea");
	
	if ((ball.x<lborder)||(ball.x>rborder))
	    return false;
	return true;
    }

    //berprft ob die Distanz zum Ball kurz genug ist
    private boolean distanz(){
	//System.out.println("check distance");
	if (Strecke(ball.x, ball.y, me.x, me.y)>maxdist)
	    return false;
	return true;
    }

    //berprft ob der Winkel zum Ball gnstig ist
    private boolean winkel(){
	//System.out.println("check direction"+ball);
	double d;
	d = ball.direction;
	if (Math.abs(d)>maxwinkel) return false;
	return true;
    }

    //berprft ob der bergebene Spieler in dem Dreieck das von den
    //beiden Torpfosten und me gebildet wird.
    private boolean beforeGoal(Element e){
	if(e.x>me.x && e.x<53 && e.y>pfostenl && e.y<pfostenr)  return true;
	return false;
	
	//System.out.println("check beforeGoal");
	/*double m1,m2,b1,b2;
	m1=(me.y-pfostenl)/me.x;
	m2=(me.y-pfostenr)/me.x;
	b1=me.y-me.x*m1;
	b2=me.y-me.x*m2;
	if ((m1*e.x+b1>=e.y)&&(m2*e.x+b2<=e.y)) return true;
	return false;*/
    }
    //Gibt den Ball aus dem Vektor zurck
    private void setBall() throws NoBallException {
	Element e;
	int i=0;
	do{
	    try{
		e=(Element)v.elementAt(i);
	    }catch (ArrayIndexOutOfBoundsException ex){
		throw (new NoBallException("Kein Ball in Elementliste"));
	    }
	    i++;
	} while (e.type!=1);
	ball=e;
	do{
	    try{
		e=(Element)v.elementAt(i);
	    }catch (ArrayIndexOutOfBoundsException ex){
		ballOld=ball;
		return;
	    }
	    i++;
	} while (e.type!=1);
	ballOld=e;
    }

    //Rechnet die Strecke zwischen 2 Koordinatenpunkten aus.
    private double Strecke(int x1, int y1, int x2, int y2){
	return Math.sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
    }


}// Defensive
