/**
 * Goalie.java
 * haelt den Kasten sauber (mehr oder weniger)
 * @author <a href="mailto:bonsai29@gmx.de">Markus Grokenberger</a>
 */


public class Goalie extends Player {
    
    private java.util.Vector v;
    private final int borderl=-53, borderr=-5;
    private int lborder, rborder;
    private final int maxdist=0;
    private double  maxwinkel=10;
    
    
    /**
     *Generiert den Goalkeeper
     *@param X hier -51 bzw. 51
     *@param Y hier 0   ---> somit steht der Goalkeeper mittig vor dem eigenen Tor
     *@param Team Der Teamname zu dem der Spieler gehrt
     *@param Host Der Hostname des Servers
     *@param Port Der Portname des Servers
     */
    
    
    public void run () {
	actor.initGoalie(TeamName);
	world.refresh();
    }

    
    public Goalie (int X, int Y,String Team, String Host, int Port) {
	super(-51,0,Team, Host, Port);
    }
    
    
    public void doSomething() {
	lborder=borderl;
	rborder=borderr;
	if(mode==0)
	  actor.moveToPosition(-51,0);
	v=world.getObjects();
	if (v.size()<1) return;
	me=(Element)v.firstElement();
	try {
	    setBall();
	}
	catch (NoBallException e) {
	    System.out.println("Goalie: searchBall()");
	    actor.searchBall();
	    return;
	}
	
	if((mode==13)||(mode==5)) { // der Goalie hat den Ball gefangen und schiesst in ins Feld zurueck
	  if(me.y>0)
          actor.moveToPosition(-38, 19);
	  else
	    actor.moveToPosition(-38,-19);
	  if((me.x==-38)&&(Math.abs(me.y)==19)) 
	    actor.shootToGoal();
	}
	
	else {                      //else-case zu if(mode==14)
	  if(mode==11) {  //abstoss !
	    if(!distanz()) {
            actor.walkToPosition(ball.x,ball.y);
	      return;
	    }
	    if(!winkel()) {
	      actor.turnToBall();
	      return;
	    }
	    actor.shootToGoal();
	  }                                      
       else {                      //else-case zu if(mode==11)
	  if(ballInArea()) {                
	    System.out.println("Goalie : Der Ball ist in meinen Bereich");
	  
	    if(Strecke(me.x,me.y,ball.x,ball.y)<=2 ) {  //catch Versuch
	       double d = ball.direction;
	       System.out.println("Goalie : Ich fang' den Ball");
	       actor.fangDenBall(d);
	       return;
	    }      
	    
          if(ball.y >  10)   // Der Goalkeeper soll sich nicht zuweit vom 5 meter Raum entfernen
	      actor.walkToPosition(-51, 10);
    	    if(ball.y < -10) 
	      actor.walkToPosition(-51,-10);
	    else
	      actor.walkToPosition(-51,ball.y);
	    
	  }                                                // if ballInArea Schleife zu Ende
	  else {
	    actor.moveToPosition(-51, 0);
	    if((me.x==-51)&&(me.y==0))
	      actor.turnToBall();
	  }
	}
    }                                                            // if(mode ==1) schleife zu ende
  	
  
 }	
    
 //ist der Ball in seinem Bereich
 private boolean ballInArea() {
     if((ball.x<lborder)||(ball.x>rborder))
	 return false;
     return true;
 }
 
    private boolean distanz() {
	//if ((Math.abs(ball.x-me.x)>maxdist)||(Math.abs(ball.y-me.y)>maxdist))
	if(Strecke(ball.x, ball.y, me.x, me.y)>maxdist)
	    return false;
	return true;
    }
 
 
 //Gibt den Ball aus dem Vektor zurck
 private void setBall() throws NoBallException {
     Element e;
     int i=0;
     do {
	 try {
	     e=(Element)v.elementAt(i);
	 }
	 catch (ArrayIndexOutOfBoundsException ex) {
	     throw (new NoBallException("Goalie : Kein Ball in Elementliste"));
	 }
	 i++;
     } 
     while (e.type!=1);
     ball=e;
     do {
	 try {
	     e=(Element)v.elementAt(i);
	 }
	 catch (ArrayIndexOutOfBoundsException ex) {
	     ballOld=ball;
	     return;
	 }
	 i++;
     } 
     while (e.type!=1);
     ballOld=e;
   }
 
    //berprft ob der Winkel zum Ball gnstig ist
    private boolean winkel(){
	double d;
        d = ball.direction;
	System.out.println("Defensive: Winkel: "+d);
	return (Math.abs(d)<=maxwinkel);	
    }
 
 //Rechnet die Strecke zwischen 2 Koordinatenpunkten aus.
 private double Strecke(int x1, int y1, int x2, int y2) {
     return Math.sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
 }
 
}// Goalie
     
