import java.util.*;
public class World {
    private Actor actor;
    Vector objects=new Vector();
    public World(Actor actor){
	this.actor=actor;
    }

    public Vector getObjects(){
	//	Element e=new Element(0,2,10,16,2);
	for (int i=0;i<objects.size();i++)
	    System.out.println("World: "+(Element)objects.elementAt(i));
	return objects;
    }
    public void refresh(){
	while(true){
	    Vector v;
	    String mes = actor.event().getMessage();
	    //	    System.out.println(mes);
	    if( mes.startsWith("(see"))
		{
		    v=objects;
		    objects = parseVisual(mes);
		    for (int i=0;i<v.size();i++){
			Element e=(Element)v.elementAt(i);
			if(e.type==1&&((Element)objects.firstElement()).time-e.time<10){
			    objects.add(e);
			    break;
			}
		    }
		}
	    else if(mes.startsWith("(hear"))
		{
		    Element e; 
		    e=parseHear(mes);
		    /*if(e==null) break;
		    double d=this.actor.richtung(e.x,e.y,actor.player.me.x,actor.player.me.y,actor.player.me.direction);
		    e.direction=d;
		    objects.add(e);*/
		}

	    else if (mes.startsWith("(sense_body")){
		/*		StringTokenizer st=new StringTokenizer(mes);
		st.nextToken();
		int t=Integer.parseInt(st.nextToken());
		sortObjects();
		for (int i=0;i<objects.size();i++){
		    Element e=((Element)objects.elementAt(i));
		    if(t-e.time>5&&e.type!=0){
			//System.out.println("World: loescheobjekt"+(Element)objects.elementAt(i));
			objects.remove(i);
			i--;
		    }
		    }*/
		this.actor.player.doSomething();
	    }
	}
    }

    private void sortObjects(){
	Vector v=new Vector();
	for (int j=0;j<=3;j++){
	    for (int i=0;i<objects.size();i++){
		int type=((Element)objects.elementAt(i)).type;
		if (type==j||(type>=100*i&&type<100*(i+1))){
		    v.add((Element)objects.remove(i));
		    i--;
		}
	    }
	}
	for (int i=0;i<v.size();i++)
	    for(int j=1;j<v.size();j++){
		Element e1,e2;
		e1=((Element)v.elementAt(i));
		e2=((Element)v.elementAt(j));
		if(e1.type==e2.type&&e1.type!=200&&e1.type!=300&&i!=j){
		    System.out.println("World: loesche: "+e1+e2);
		    if 	(e1.time<e2.time){
			v.remove(i);
			i--;
			if(j>i) j--;
		    }
		    else{
			v.remove(j);
			j--;
			if(i>j)i--;
		    }
		    
		}
	    }
	objects=v;
    }
    private Element parseHear(String message){
	String token;
	Element e=new Element();
	StringTokenizer st=new StringTokenizer(message);
	try {
	    token =st.nextToken();
	    System.out.println(token);
	    token =st.nextToken();
	    System.out.println(token);
	    try{
		e.time=Integer.parseInt(token);
	    }catch (NumberFormatException ex){return null;}
	    token =st.nextToken();
	    //	    System.out.println(token);
	    if (token.startsWith("referee")){
		this.actor.player.setPlaymode(st.nextToken());
		return null;
	    }
	    if ((!token.startsWith("online_coach"))
		&&(!token.startsWith("referee"))
		&&(!token.startsWith("self"))) {
		token =st.nextToken();
		System.out.println(token);
		if (token.startsWith("\"BallX")){
		    try{
			e.x=Integer.parseInt(st.nextToken());
		    }catch (NumberFormatException exc){ return null;}
		}
		else return null;
		token =st.nextToken();
		System.out.println(token);
		if (token.startsWith("BallY")){
		    try{
			e.y=Integer.parseInt(st.nextToken());
		    }catch (NumberFormatException nfe){ return null;}
		}
		else return null;

	    }
	}catch (NoSuchElementException nse){return null;}
	e.type=1;
	return e;
    }

     private Vector parseVisual(String s)
    {
	//	System.out.println("World: "+s);
	Vector v = new Vector();
	double objectX=0, objectY=0, direction=0, distance=0, absDirection=0, Balldirection=0, Balldistance=0;
	double pdirection=0, pdistance=0;
	int PlayerX = 0;
	int PlayerY = 0;
	boolean gefunden = false;
	boolean ballgesehen=false;
	Vector p = new Vector();

	StringTokenizer tokenizer = new StringTokenizer(s, "()");
        String mm =tokenizer.nextToken().substring(4).trim();
        int time = Integer.parseInt(mm);
	System.out.println("World: "+ time);

	while (tokenizer.hasMoreTokens())
	{
		String code = tokenizer.nextToken();

		if (!code.equals(" "))
		    {
			String data="";
			try{
			    data = tokenizer.nextToken();
			}catch (NoSuchElementException nsee){break;}

		//	tokenizer.nextToken();

			//System.out.println("World: Code: "+code+data);
			switch(code.charAt(0))
			{
				case 'b':
				    StringTokenizer st0 = new StringTokenizer(data, " ");
				    Balldistance = Double.valueOf(st0.nextToken()).doubleValue();
				    Balldirection = Double.valueOf(st0.nextToken()).doubleValue();
				    //System.out.println("World: Ball: "+Balldistance+" "+Balldirection);
				    ballgesehen=true;
				    break;

				case 'g':
				if(!gefunden)
				{
					StringTokenizer st1 = new StringTokenizer(data, " ");
				      distance = Double.valueOf(st1.nextToken()).doubleValue();
				      direction = Double.valueOf(st1.nextToken()).doubleValue();
			      	objectY = 0;
				      if(code.startsWith("g r")) objectX = 52.5;
				      else objectX = -52.5;
				      gefunden = true;
			      	break;
					}
				else {break;}

				case 'f':
				if(!gefunden)
				{
					StringTokenizer st2 = new StringTokenizer(data, " ");
				      distance = Double.valueOf(st2.nextToken()).doubleValue();
			      	direction = Double.valueOf(st2.nextToken()).doubleValue();

			      	switch(code.charAt(2))
				      {
				      case 'c':
					  objectX = 0;
					  if(code.length()<5) {
					      objectY = 0;
					      break;
					  }
					  if (code.charAt(4)=='t') {objectY = -34;}
					  else if (code.charAt(4) == 'b') {objectY = 34;}
					  break;
					  
				      case 'g':
					  if(code.charAt(4)=='l')
					      {
						  objectX = -52.5;
						  if(code.charAt(6)=='t') {objectY = -7.01;}
						  else {objectY = 7.01;}
					      }
					  else
					      {
						  objectX = 52.5;
						  if(code.charAt(6)=='t') {objectY = -7.01;}
						  else {objectY = 7.01;}
					      }
			      		break;
					
				      case 'p':
					  if(code.charAt(4)=='l')
					      {
						  objectX = -35.7;
						  if(code.charAt(6)=='t') {objectY = -19.7;}
						  else if(code.charAt(6)=='b') {objectY = 19.7;}
					      	else {objectY = 0;}
					      }
					  else if(code.charAt(4)=='r')
					      {
						  objectX = 35.7;
						  if(code.charAt(6)=='t') {objectY = -19.7;}
						  else if(code.charAt(6)=='b') {objectY = 19.7;}
						  else {objectY = 0;}
					      }
					  break;
					  
				      case 'l':
					  objectX = -57.5;
					  if(code.charAt(4)=='t')
					      {
						  if(code.endsWith("t"))
						      {
							  objectX = -52.5;
							  objectY = -34;
						      }
						  else
						      {
					       		double i = Double.parseDouble(code.substring(6,8));
						            objectY = 0-i;
					       		}
					       	}
				      	else if(code.charAt(4)=='b')
				      	{
				      		if(code.endsWith("b"))
					      	{
					       		objectX = -52.5;
					      		objectY = 34;
				      			}
					      	else
					      	{
					      	      double i = Double.parseDouble(code.substring(6,8));
					      	      objectY = i;
						      	}
					       	}
				      	else {objectY = 0;}
				      	break;

		      			case 'r':
			       		objectX = 57.5;
				      	if(code.charAt(4)=='t')
				      	{
				       		if(code.endsWith("t"))
					      	{
				         			objectX = 52.5;
					       		objectY = -34;
					      		}
				      		else
					      	{
					       	      double i = Double.parseDouble(code.substring(6,8));
					       	      objectY = 0-i;
					      		}
				      		}
				      	else if(code.charAt(4)=='b')
			       		{
				      		if(code.endsWith("b"))
				      		{
					      		objectX = 52.5;
						       	objectY = 34;
						      	}
					      	else
					      	{
					                  double i = Double.parseDouble(code.substring(6,8));
						            objectY = i;
						      	}
					      	}
				      	else {objectY = 0;}
		       			break;

				      	case 't':
				      	objectY = -39;
				      	if(code.charAt(4)=='l')
				      	{
					      	double i = Double.parseDouble(code.substring(6,8));
					      	objectX = 0-i;

					      	}
				      	else if(code.charAt(4)=='r')
				      	{
				       		double i = Double.parseDouble(code.substring(6,8));
					      	objectX = i;
					      	}
				      	else {objectX = 0;}
				      	break;

				      	case 'b':
				      	objectY = 39;
				      	if(code.charAt(4)=='l')
				      	{
					      	double i = Double.parseDouble(code.substring(6,8));
					      	objectX = 0-i;
					      	}
				      	else if(code.charAt(4)=='r')
				      	{
					      	double i = Double.parseDouble(code.substring(6,8));
					      	objectX = i;
					      	}
				      	else {objectX = 0;}
				      	break;
				      	}
			            gefunden = true;
			            break;
					}
			      else {break;}



				case 'p':
                                if(code.length()>3 && !data.equals(" "))
                                {
                                p.add(code);
				p.add(data);
                                break;}
                                else break;
				/*	case 'p':
				p.add(code);
				p.add(data);
				break;*/

				case 'l':
				int neg = 0;
				StringTokenizer st3 = new StringTokenizer(data, " ");
				if(st3.countTokens()<2) {
				    System.out.println("World: String: "+data);
				    absDirection=0;
				    break;
				}
				st3.nextToken();
				try{
				    absDirection = Double.valueOf(st3.nextToken()).doubleValue();
				}catch(NumberFormatException nfe){}
				if(absDirection < 0){neg = 1;}
				switch(code.charAt(2))
				{
				case 'l':
				   if(actor.player.getDirection()){
                                      if(neg == 1){
					
                                           if(absDirection==-90){
                                                  absDirection = 180;
                                                   break;}
					else{
					    absDirection = 90 - absDirection;
					    break;}
				    }
				    else {
                                        absDirection = -90-absDirection;
					break;}}
				    else{
					if(neg == 1){
					    if(absDirection==-90){
                                                  absDirection=0;
                                                   break;}
					    else{
						absDirection=-90-absDirection;
						break;}
					}
					else{
					    absDirection=90-absDirection;
					    break;}
					
				    }

				case 't':
				   if(actor.player.getDirection()){
                                    if(neg == 1){absDirection = -180 - absDirection;}
					else {absDirection = 0-absDirection;}
				    break;}
				   else{
				       if(neg==1){
					    absDirection=-absDirection;}
				       
				       else{absDirection=90+absDirection;}
				       break;
				    }

				case 'r':
				    if(actor.player.getDirection()){
				    if(neg == 1) {if(absDirection==-90){absDirection = 0;}
				    else{
					absDirection = -90 - absDirection;}
				    }
				    else {absDirection = 90-absDirection;}
				    break;}
				    else{
					if(neg==1){
					   absDirection=90-absDirection;}
					else{absDirection=-90-absDirection;}
					break;}
				case 'b':
				    if(actor.player.getDirection()){
                                    if(neg == 1){
                                         absDirection = 0 - absDirection;}
				    else {absDirection = 180-absDirection;}
				    break;}
				       else{
					   if(neg==1){
					       if(absDirection==-90){absDirection=-90;}
					       else{
						   absDirection=-180-absDirection;}
					       break;}
					   else{
					       absDirection=-absDirection;
					       break;}}
				}
				break;
				}

			}

		}
	//System.out.println(objectX);
         int gd=1;
         if(!actor.player.getDirection()) {gd=-1;}
		direction = (direction+absDirection)/180;
		direction = direction * Math.PI;
		objectX = gd*objectX-distance*Math.cos(direction);
            PlayerX = (int)Math.round(objectX);
		objectY =gd*objectY-distance*Math.sin(direction);
            PlayerY = (int)Math.round(objectY);
            v.add(new Element(time, 0, PlayerX, PlayerY, absDirection));
	    if(ballgesehen){
		Element b = new Element();
                b = Berechnung(time, 1, Balldirection, absDirection, Balldistance, objectX, objectY);
		v.add(b);
	    }

	    /*            if(!p.isEmpty())
		{
		    for(int i=0; i<p.size(); i=i+2)
			{
			    String tn;
			    int tp,nr;
			    StringTokenizer per = new StringTokenizer((String)p.get(i), " ");
			    per.nextToken();
			    if(per.hasMoreTokens()){
				tn = per.nextToken();
				if (per.hasMoreTokens())
				    nr = Integer.parseInt(per.nextToken());
				else nr=0;
			    }
			    else {
				tn=actor.TeamName+"a";
				nr=0;
			    }
			    if(tn==actor.TeamName)      //???
				{
				    tp = 200+nr;
				}
			    else {tp = 300+nr;}
			    StringTokenizer da = new StringTokenizer((String)p.get(i+1), " ");
			    pdistance = Double.valueOf(da.nextToken()).doubleValue();
			    if(da.hasMoreTokens())pdirection = Double.valueOf(da.nextToken()).doubleValue();
			    Element pe = new Element();
                            pe = Berechnung(time, tp, pdirection, absDirection, pdistance, objectX, objectY );
			    v.add(pe);
            		}
            	}*/
            if(!p.isEmpty())
		{
		    for(int i=0; i<p.size(); i=i+2)
			{
			    String tn;
			    int tp,nr;
			    StringTokenizer per = new StringTokenizer((String)p.get(i), " ");
			    per.nextToken();
                            tn = per.nextToken();
                            int l = tn.length()-1;
                            tn = tn.substring(1, l);
                            
                            if(per.hasMoreTokens())
				{nr = Integer.parseInt(per.nextToken());}
                            else {nr = 0;}
                            if(tn.equals(actor.TeamName))      
				{
                                    
                                    tp = 200+nr;
				}
			    else {tp = 300+nr;}
                            System.out.println("World: Type"+tp);
			    StringTokenizer da = new StringTokenizer((String)p.get(i+1), " ");
                            pdistance = Double.valueOf(da.nextToken()).doubleValue();
                            if(da.hasMoreTokens())
				try{
				    pdirection = Double.valueOf(da.nextToken()).doubleValue();
				}catch(NumberFormatException nfe){pdirection=0;}
			    Element pe = new Element();
			    
			    pe = Berechnung(time, tp, pdirection, absDirection, pdistance, objectX, objectY );
			    
			    v.add(pe);
            		}
            	}
	    return v;
	    
	  }

    private Element Berechnung(int time, int Type, double dir1, double dir2, double dis, double PlayerX, double PlayerY )
    {
	int t = time;
	int ty = Type;
        double di = ((dir1+dir2)/180)*Math.PI;
	double x = PlayerX+dis*Math.cos(di);
	double y = PlayerY+dis*Math.sin(di);
	int a = (int)Math.round(x);
	int b = (int)Math.round(y);
        return new Element(t, ty, a, b, dir1);
    }






}

